with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLFrameElement_Interface is

   procedure Initialize (This : in out IHTMLFrameElement_Type) is
   begin
      Set_IID (This, IID_IHTMLFrameElement);
   end Initialize;

   function Pointer (This : IHTMLFrameElement_Type)
     return Pointer_To_IHTMLFrameElement
   is
   begin
      return To_Pointer_To_IHTMLFrameElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLFrameElement_Type;
                     Pointer : in     Pointer_To_IHTMLFrameElement)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_borderColor
     (This : IHTMLFrameElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_borderColor
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_borderColor;

   function Get_borderColor
     (This : IHTMLFrameElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderColor;

end MSHTML.IHTMLFrameElement_Interface;

